<!-- 视频列表 -->
<template>
    <div class="table-box">
        <div style="padding-bottom: 16px">
            <el-button type="primary" @click="handleAdd"> 添加 </el-button>
            <el-button type="primary" @click="handleExport"> 导出 </el-button>
        </div>
        <ProTable
            ref="proTableRef"
            :formData="dataStore.formData"
            :columns="dataStore.columns"
            :request-api="getMallListApi"
            :init-param="dataStore.initParam"
        >
            <template #image="scope">
                <el-image :src="scope.row.image ? h + scope.row.image : ''" style="width: 60px; height: 60px" />
            </template>
            <template #disabled="scope">
                <el-tag :type="scope.row.disabled == 1 ? 'danger' : 'success'" effect="dark">{{
                    scope.row.disabled == 1 ? "禁用" : "启用"
                }}</el-tag>
            </template>
            <template #operation="scope">
                <el-button size="small" type="primary" @click="handleBtnClick('编辑', scope.row)">编辑</el-button>
                <el-button size="small" type="danger" @click="handleBtnClick('删除', scope.row)">删除</el-button>
            </template>
        </ProTable>
        <el-drawer
            v-model="dataStore.visible"
            :show-close="true"
            :size="600"
            :close-on-click-modal="false"
            :close-on-press-escape="false"
            :before-close="handleBeforeClone"
            destroy-on-close
        >
            <template #header="{ titleId, titleClass }">
                <h4 :id="titleId" :class="titleClass">{{ dataStore.title }}</h4>
            </template>
            <div>
                <rulesForm
                    :ruleForm="dataStore.editRuleForm"
                    :formData="dataStore.editFormData"
                    :rules="dataStore.rules"
                    ref="formRef"
                    @handleSelectChangeEmits="handleSelectChangeEmits"
                >
                </rulesForm>
            </div>
            <template #footer>
                <div style="flex: auto">
                    <el-button @click="handleResetClick">重置</el-button>
                    <el-button type="primary" @click="handleConfirmClick">确认</el-button>
                </div>
            </template>
        </el-drawer>
    </div>
</template>

<script setup lang="ts" name="videoListIndex">
import ProTable from "@/components/ProTable/index.vue";
import rulesForm from "@/components/rulesForm/index.vue";
import { messageBox } from "@/utils/messageBox";
import { useMsg } from "@/hooks/useMsg";

//列表接口
import {
    getMallListApi,
    getMallDelApi,
    getMallDetailsApi,
    getMallUpApi,
    getMallSaveApi,
    getMallUpExportApi
} from "@/api/modules/commodity";

import { recursiveCompare } from "@/utils/recursiveCompare";
//深拷贝方法
import { cloneDeep } from "lodash-es";
//表格和搜索條件
import { RULE_FORM, FORM_DATA, COLUMNS, EDIT_FORM_DATA, EDIT_RULE_FORM, RULES } from "./constant/index";
import { useExport } from "@/hooks/useExport";
// 获取 ProTable 元素，调用其获取刷新数据方法（还能获取到当前查询参数，方便导出携带参数）
const proTableRef = ref<any>(null);
const formRef: any = ref(null);
//图片地址
import { h } from "@/utils/url";
// 数据源
const dataStore = reactive<any>({
    title: "添加产品推荐",
    columns: COLUMNS, //列表配置项
    rules: cloneDeep(RULES), //抽屉表单验证
    editRuleForm: cloneDeep(EDIT_RULE_FORM),
    editFormData: cloneDeep(EDIT_FORM_DATA), //抽屉表单配置项
    initParam: cloneDeep(RULE_FORM), // 初始化搜索条件|重置搜索条件
    ruleForm: cloneDeep(RULE_FORM), // 搜索參數
    formData: FORM_DATA, //搜索配置项
    visible: false,
    selectRow: {} //当前选择的row
});

//抽屉确认
const handleConfirmClick = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef!.validate((valid: any) => {
        if (valid) {
            dataStore.title === "添加产品推荐" ? getMallSave() : getMallUp();
        } else {
            console.log("error submit!");
            return false;
        }
    });
};
//重置验证状态
const resetFields = () => {
    if (!formRef.value!.ruleFormRef) return;
    formRef!.value!.ruleFormRef.resetFields();
};
//抽屉重置
const handleResetClick = () => {
    if (dataStore.title === "添加产品推荐") {
        resetFields();
    } else {
        getMallDetails(dataStore.selectRow.id);
    }
};

//添加
const handleAdd = () => {
    dataStore.visible = true;
    dataStore.title = "添加产品推荐";
};
//抽屉关闭前的钩子
const handleBeforeClone = () => {
    dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
    resetFields();
    dataStore.visible = false;
};
//详情
const getMallDetails = async (id: any) => {
    const result = await getMallDetailsApi(id);
    if (result?.code === 0) {
        dataStore.editRuleForm = result?.data;
        let is = dataStore.editFormData[1].options.some((item: any) =>
            recursiveCompare(item, dataStore.editRuleForm.category_id)
        );
        dataStore.editRuleForm.category_id1 = is ? dataStore.editRuleForm.category_id : dataStore.editRuleForm.category_name;
    }
};

const handleSelectChangeEmits = (value: any) => {
    if (value.prop === "category_id1") {
        dataStore.editRuleForm.category_id = value.id;
    }
};

//保存
const getMallSave = async () => {
    const result = await getMallSaveApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        const { msg } = result;
        useMsg("success", msg);
        dataStore.visible = false;
        dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
        proTableRef?.value?.getTableList();
    }
};
//更新
const getMallUp = async () => {
    const result = await getMallUpApi(dataStore.editRuleForm);
    if (result?.code === 0) {
        const { msg } = result;
        useMsg("success", msg);
        dataStore.visible = false;
        dataStore.editRuleForm = cloneDeep(EDIT_RULE_FORM);
        proTableRef?.value?.getTableList();
    }
};
//导出接口
const getMallUpExport = async () => {
    const result = await getMallUpExportApi({
        ...proTableRef?.value?.searchParam,
        ...proTableRef?.value?.pageable
    });
    await useExport(result);
};
//删除
const getMallDel = (id: any) => {
    messageBox("你确定要删除?", async () => {
        const result = await getMallDelApi(id);
        if (result?.code === 0) {
            const { msg } = result;
            useMsg("success", msg);
            proTableRef?.value?.getTableList();
        }
    });
};
//按钮点击事件
const handleBtnClick = (type: any, row: any) => {
    dataStore.selectRow = row;
    //编辑
    if (type === "编辑") {
        dataStore.visible = true;
        dataStore.title = "编辑产品推荐";
        getMallDetails(row.id);
        return;
    }
    //删除
    if (type === "删除") {
        getMallDel(row.id);
    }
};
//导出
const handleExport = () => {
    getMallUpExport();
};
</script>

<style scoped></style>
